import apsw
import time
# import string
# from string import strip, lower, upper, join

class Record :
    def __init__(self,data) :
        self.__data = data
        for i in data.keys() :
            setattr(self,i,data[i])
    
    def __str__(self) :
        a = self.__data
        f = []
        for i in a.keys() :
            f.append("%s : %s" % (i,str(a[i])))
        return '[%s]' % '\n'.join(f)

def str2unicode(s) :
    if type(s) == type('') :
        try :
            ret = unicode(s,local_encoding)
            return ret
        except :
            pass
        try :
            ret = unicode(s,'utf8')
            return ret
        except :
            return s
    return s

def unicode2str(s) :
    t = type(s)
    if t == type(5) :
        return long(s)
    if t == type(u"w") :
        return s.encode('utf8')
    return s
    
def argConvert(args) :
    if args==None :
        return None
    t = type(args)
    if t==type(()) or t==type([]) :
        return [str2unicode(i) for i in args]
    if t==type({}) :
        for i in args.keys() :
            args[i] = str2unicode(args[i])
        return args
    return args
    
class SQLite3 :

    def __init__(self,dbpath) :
        self.offset = -1
	self.dbpath = dbpath
        self.results = None
	self.con = None
	self.cursor = None
	self._connection()

    def _connection(self) :
        self.con = apsw.Connection(self.dbpath)
        self.cursor = self.con.cursor()

    def _eatCursorNext(self) :
        if self.cursor==None :
	    return None
	r = 1
        while r :
            try :
                r = self.cursor.next()
            except :
                return

    def SQL(self,cmd,args=(),retry=0) :
        if self.con==None :
            return -1	    
	self._eatCursorNext()
        args = argConvert(args)
        self.lastSQL = cmd
        self.desc = None
        # print cmd
        try :
            self.results = self.cursor.execute(cmd,args)
            return 0
        except apsw.BusyError,e:
            try :
                self.cursor.next()
            except :
                pass
            if retry >20 :
                print "execute:(",cmd,")Busy, error",e
                self.results = None
                return -1
            time.sleep(0.01)
            return self.SQL(cmd,args,retry + 1)
        except apsw.LockedError,e :
            if retry >20 :
                print "execute:(",cmd,")Locked, error",e
                self.results = None
                return -1
            time.sleep(0.01)
            return self.SQL(cmd,args,retry + 1)
        except apsw.Error,e:
            print 'execute:',cmd,'error',e
            self.results = None
            return -1
    
    def FETCH(self) :
        if self.results == None :
            return None
        if self.desc == None :
            try :
                self.desc = self.results.getdescription()
            except apsw.ExecutionCompleteError :
                # print "getdescription error",self.lastSQL
                return None
            except :
                print "fetch error"
                return None
        try :
            desc = self.desc
            d  = self.results.next()
            data = {}
            for i in range(len(d)) :
                data[desc[i][0]] = unicode2str(d[i])
            return Record(data)
        except StopIteration :
            return None
        except apsw.Error,e:
            print "error happen",e,self,lastSQL
            return None
        
    def COMMIT(self) :
        try :
            self.cursor.execute("COMMIT")
        except apsw.Error,e:
            print "commit error",type(e),e
            
    def ROLLBACK(self) :
        try :
            self.cursor.execute("ROLLBACK")
        except apsw.Error,e:
            print "rollback error",type(e),e
 
    def BEGIN(self) :
        try :
            self.cursor.execute("BEGIN")
        except apsw.Error,e:
            print "begin error",type(e),e
    
    def CLOSE(self) :
        self.con = None
	self.cursor = None
